'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.webpackReactLoadable = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _webpack = require('react-loadable/webpack');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var webpackReactLoadable = exports.webpackReactLoadable = function webpackReactLoadable(config) {
    var settings = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    config.plugins = [].concat((0, _toConsumableArray3.default)(config.plugins), [new _webpack.ReactLoadablePlugin({
        filename: settings.target || './build/react-loadable.json'
    })]);

    // "chunks:all" generates some unpredictable chunks based on "node_modules"
    // that are not detected by "react-loadable", hence will cause some flickering
    // in the rendering because the chunk itself is not going to be places into
    // the initial HTML rendering.
    config.optimization = (0, _extends3.default)({}, config.optimization, {
        splitChunks: { chunks: 'initial' }
    });

    return config;
}; // @TODO: this guy has a similar project, with the same problem
// https://github.com/andreiduca/cra-ssr-code-splitting/issues/7
// (seems solved with "chunks:initial")